/*
 * This module contains the main() function for fc-sertool: the simplest
 * of the FreeCalypso loading tools, which sends the user-specified
 * IRAM SREC image to the boot ROM and then switches into serial tty
 * pass-through.
 */

#include <sys/types.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "srecreader.h"

extern char *target_ttydev;
extern struct srecreader iramimage;

main(argc, argv)
	char **argv;
{
	extern char *optarg;
	extern int optind;
	int c;

	while ((c = getopt(argc, argv, "h:H:i:")) != EOF)
		switch (c) {
		case 'h':
			read_hwparam_file_shortname(optarg);
			continue;
		case 'H':
			read_hwparam_file_fullpath(optarg);
			continue;
		case 'i':
			set_beacon_interval(optarg);
			continue;
		case '?':
		default:
usage:			fprintf(stderr,
			"usage: fc-sertool [options] ttyport iramimage.srec\n");
			exit(1);
		}
	if (argc - optind != 2)
		goto usage;
	target_ttydev = argv[optind];
	iramimage.filename = argv[optind+1];

	open_target_serial();
	perform_romload();
	tty_passthru();
	exit(0);
}

/* called from hwparam.c config file parser */
/* stub needed for fc-sertool to link */
void
set_default_exit_mode()
{
}
