/*
 * This module implements the dispatch of interactively entered
 * commands to their respective implementation functions via cmdtab.
 */

#include "cmdtab.h"

extern char command[];
extern struct cmdtab cmdtab[];

void
command_dispatch()
{
	char *cp, *np;
	struct cmdtab *tp;

	for (cp = command; *cp == ' '; cp++)
		;
	if (!*cp)
		return;
	for (np = cp; *cp && *cp != ' '; cp++)
		;
	if (*cp)
		*cp++ = '\0';
	for (tp = cmdtab; tp->cmd; tp++)
		if (!strcmp(tp->cmd, np))
			break;
	if (tp->func)
		tp->func(cp);
	else
		printf("ERROR: unknown or unimplemented command\n");
}
